<div class="contenedor">
  <app-side-bar></app-side-bar>
  <div class="position-relative">
    <div class="position-relative d-flex justify-content-between align-items-center p-3 bar">
      <!-- Titulo de la página, buscador y calendario -->
      <div class="d-flex row">
        <h1 class="max-content">Incidencias</h1>
      </div>
      <div class="d-flex">
        <!-- Calendario -->
        <div class="d-flex align-items-center position-relative">
          <div [ngClass]="{'pressed-button': startDate.value !== ''}" class="pressed-button me-4">
            <img class="cursor-pointer" (click)="openCalendar()" src="assets/img/calendario.svg">
          </div>
          <form #calendar class="col visibility-hidden sombra calendario">
            <img class="cross position-absolute cursor-pointer" (click)="closeCalendar()" src="assets/img/xmark.svg">
            <div class="row d-flex mb-3">
              <div class="col-sm-6 max-content mb-2">
                <p class="max-content">Inicio</p>
                <input #startDate type="date">
              </div>
              <div class="col-sm-6 max-content mb-2">
                <p class="max-content">Fin</p>
                <input #endDate type="date">
              </div>
            </div>
            <div class="justify-content-center d-flex">
              <button (click)="removeDate()" class="btn btn-outline-secondary me-3">Borrar</button>
              <button (click)="searchDate()" class="btn btn-primary text-white">Buscar</button>
            </div>
          </form>
        </div>
        <!-- Buscador -->
        <div class="position-relative align-items-center d-flex">
          <input #searchInput (input)="search($event)" class="align-self-center buscador entrada sombra" type="text" placeholder="Buscar" name="buscar">
          <ul *ngIf="searchResults.length > 0" class="list-group position-absolute busqueda">
            <li *ngFor="let result of searchResults" class="list-group-item" (click)="selectResult(result)">
              <span [innerHTML]="result"></span>
            </li>
          </ul>
        </div>
      </div>
    </div>
    <!-- Tabla -->
    <div class="alturaTabla">
      <table class="table table-hover">
        <thead>
          <tr>
            <!-- <th>
              <div class="d-flex align-items-center">
                <div class="custom-control custom-checkbox ml">
                  <input type="checkbox" class="custom-control-input" id="customCheck2">
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th> -->
            <th>
              <div class="d-flex tamCelda align-items-center">
                <div>
                  Código
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'codigo')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'codigo')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex tamCelda align-items-center">
                <div>
                  Cód. Proyecto
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'proyecto')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'proyecto')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Nombre Proyecto
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex tamCelda align-items-center">
                <div>
                  Usuario
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'autor')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'autor')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Fecha
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'fechaCreacion')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'fechaCreacion')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Descripción
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'descripcion')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'descripcion')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  C1
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  C2
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Disciplina
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'disciplina')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'disciplina')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Fotos
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Audios
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Videos
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Estado
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'estado')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'estado')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Acciones
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
          </tr>
        </thead>
        <tbody *ngIf="loadCompleted">
          <tr *ngFor="let incidencia of incidencias; let i = index">
            <!-- <td>
              <div class="custom-control custom-checkbox ml tamCelda0">
                  <input type="checkbox" class="custom-control-input" id="customCheck2">
              </div>
            </td> -->
            <td class="align-items-center">{{incidencia.codigo}}</td>
            <td class="align-items-center">{{incidencia.proyectoCod}}</td>
            <td class="align-items-center" [title]="incidencia.proyectoNombre">
              <div class="tamCelda3 ellipsis">
                {{incidencia.proyectoNombre}}
              </div>
            </td>
            <td class="align-items-center" [title]="incidencia.autorNombre">
              <div class="tamCelda2 ellipsis">
                {{incidencia.autorNombre}}
              </div>
            </td>
            <td class="align-items-center">{{incidencia.fechaCreacion | date:'dd/MM/yy, h:mm a'}}</td>
            <td class="align-items-center" [title]="incidencia.descripcion">
              <div class="tamCelda2 ellipsis">
                {{incidencia.descripcion}}
              </div>
            </td>
            <td class="align-items-center">{{incidencia.complemento1}}</td>
            <td class="align-items-center">{{incidencia.complemento2}}</td>
            <td class="align-items-center">
              <div *ngFor="let disciplina of incidencia.disciplinas">
                <p>{{disciplina}}</p>
              </div>
            </td>
            <td class="align-items-center link">
              <div *ngFor="let documento of incidencia.documentos.fotos">
                <p class="cursor-pointer" (click)="descargar(documento)">{{documento}}</p>
              </div>
            </td>
            <td class="align-items-center link">
              <div *ngFor="let documento of incidencia.documentos.audios">
                <p class="cursor-pointer" (click)="descargar(documento)">{{documento}}</p>
              </div>
            </td>
            <td class="align-items-center link">
              <div *ngFor="let documento of incidencia.documentos.videos">
                <p class="cursor-pointer" (click)="descargar(documento)">{{documento}}</p>
              </div>
            </td>
            <td class="align-items-center">
              <div class="states d-flex justify-content-between">
                <div (click)="downloadPdf(incidencia, 'incidencia')" [ngClass]="{'creada': incidencia.estado === 'creada'}" class="cursor-pointer" title="Creada"></div>
                <div
                  (click)="downloadPdf(incidencia, 'inspecciones')"
                  [ngClass]="{
                    'borderConforme': incidencia.estado === 'conforme',
                    'conformeIncidencia': incidencia.estado === 'conforme',
                    'borderNoConforme': incidencia.estado === 'no conforme',
                    'noconformeIncidencia': incidencia.estado === 'no conforme'}"
                  class="cursor-pointer"
                  [title]="
                  incidencia.estado === 'conforme' ? 'Conforme' :
                  incidencia.estado === 'no conforme' ? 'No conforme' :
                  'Conforme/No conforme'"
                  ></div>
                <div (click)="downloadPdf(incidencia, 'cerrada')" [ngClass]="{'cerrada': incidencia.estado === 'cerrada'}" class="cursor-pointer" title="Cerrada"></div>
              </div>
            </td>
            <td class="align-items-center">
              <div class="d-flex">
                <img title="Descargar" (click)="downloadPdf(incidencia, 'all')" class="cursor-pointer me-1" src="assets/img/download.svg">
                <img title="Blockchain" (click)="downloadPdf(incidencia, 'all', true); openBlockChainModal(true, incidencia.uid)" class="cursor-pointer me-1" src="assets/img/blockchain.svg">
                <img *ngIf="incidencia.blockChainId; else disabledDownload" title="Descargar blockchain" (click)="downloadZip(incidencia.blockChainId, incidencia.codigo)" class="cursor-pointer me-1" src="assets/img/download-zip.svg">
                <ng-template #disabledDownload>
                  <img title="Descargar blockchain" class="me-1 graFilter" src="assets/img/download-zip-grey.svg">
                </ng-template>
                <img title="Avisar" (click)="abrirAviso(incidencia)" class="cursor-pointer me-1" src="assets/img/forward-arrow.svg">
                <img title="Eliminar" (click)="deleteIncidencia(incidencia)" class="cursor-pointer" src="assets/img/delete.svg">
              </div>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <!-- Loading -->
    <div class="d-flex justify-content-center loading" *ngIf="!loadCompleted">
      cargando
    </div>
    <!-- Paginacion -->
    <div class="mt-2 position-absolute bottom-0 w-100">
      <app-pagination (changePage)="changePage($event)" [dataLoaded]="loadCompleted" [recordsTotal]="recordsTotal" [recordCurrent]="recordCurrent + 1" [recordsPerPage]="recordsPerPage"></app-pagination>
    </div>
    <!-- Modal Notificacion-->
    <div #avisoIncidencia class="visibility-hidden">
      <app-notify-form  (cancel)="cancelNotify()" [notificationData]="notificationData" [notificationPdf]="notificationPdf"></app-notify-form>
    </div>

    <!-- Modal Blockchain-->
    <section #blockChainModal class="ventanaModal d-flex justify-content-center align-items-center visibility-hidden">
      <div class="modalContent">
        <h4 class="text-white text-center">Blockchain</h4>
        <div class="p-3">
          <div class="mb-3">
            <div class="d-flex align-items-center mb-2">
              <div class="enum p-1 text-center me-2 d-flex align-items-center justify-content-center">1</div>
              <p>Se descargará el <strong>PDF</strong> de la incidencia completa.</p>
            </div>
            <div class="d-flex align-items-center mb-2">
              <div class="enum p-1 text-center me-2 d-flex align-items-center justify-content-center">2</div>
              <p>Adjunte el <strong>PDF  descargado</strong>.</p>
            </div>
            <div class="d-flex align-items-center">
              <div class="enum p-1 text-center me-2 d-flex align-items-center justify-content-center">3</div>
              <p>Al pulsar al botón enviar, se descargará un <strong>ZIP</strong> con el <strong>PDF procesado</strong> con <strong>blockchain</strong>.</p>
            </div>
          </div>
          <input #inputFileBc class="form-control mb-2" id="upload" aria-label="Seleccionar archivos" (change)="addFileBlockChain($event)" type="file" required>
          <div class="d-flex justify-content-center">
            <button (click)="openBlockChainModal(false)" type="button" class="btn text-white bgGray me-4">Cancelar</button>
            <button (click)="sendToCodeContract()" class="btn btn-primary text-white">Enviar</button>
          </div>
        </div>
      </div>
    </section>

  </div>
</div>
